gtkmm: Gtk::NumericSorter< T > Class Template Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Gtk::NumericSorter< T > Class Template Reference
ListView Classes

Sort by comparing numbers. More...

`#include <gtkmm/numericsorter.h>`

Inheritance diagram for Gtk::NumericSorter< T >:
[legend]

## Public Member Functions
Glib::RefPtr< Expression< T > > | get_expression ()
| Gets the expression that is evaluated to obtain numbers from items.
Glib::RefPtr< const Expression< T > > | get_expression () const
| Gets the expression that is evaluated to obtain numbers from items.
void | set_expression (const Glib::RefPtr< Expression< T > > &expression)
| Sets the expression that is evaluated to obtain numbers from items.
Glib::PropertyProxy< Glib::RefPtr< Expression< T > > > | property_expression ()
| The expression to evalute on items to get a number to compare with.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< T > > > | property_expression () const
| The expression to evalute on items to get a number to compare with.
Public Member Functions inherited from Gtk::NumericSorterBase
| NumericSorterBase (NumericSorterBase &&src) noexcept
NumericSorterBase & | operator= (NumericSorterBase &&src) noexcept
| ~NumericSorterBase () noexcept override
GtkNumericSorter * | gobj ()
| Provides access to the underlying C GObject.
const GtkNumericSorter * | gobj () const
| Provides access to the underlying C GObject.
GtkNumericSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
SortType | get_sort_order () const
| Gets whether this sorter will sort smaller numbers first.
void | set_sort_order (SortType sort_order)
| Sets whether to sort smaller numbers before larger ones.
Glib::PropertyProxy< SortType > | property_sort_order ()
| Whether the sorter will sort smaller numbers first.
Glib::PropertyProxy_ReadOnly< SortType > | property_sort_order () const
| Whether the sorter will sort smaller numbers first.
Public Member Functions inherited from Gtk::Sorter
| Sorter (Sorter &&src) noexcept
Sorter & | operator= (Sorter &&src) noexcept
| ~Sorter () noexcept override
GtkSorter * | gobj ()
| Provides access to the underlying C GObject.
const GtkSorter * | gobj () const
| Provides access to the underlying C GObject.
GtkSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Ordering | compare (gpointer item1, gpointer item2)
| Compares two given items according to the sort order implemented by the sorter.
Order | get_order () const
| Gets the order that self conforms to.
void | changed (Change change)
| Notifies all users of the sorter that it has changed.
Glib::SignalProxy< void(Change)> | signal_changed ()

## Static Public Member Functions
static Glib::RefPtr< NumericSorter > | create (const Glib::RefPtr< Expression< T > > &expression)
Static Public Member Functions inherited from Gtk::NumericSorterBase
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Sorter
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| NumericSorter (const Glib::RefPtr< Expression< T > > &expression)
Protected Member Functions inherited from Gtk::NumericSorterBase
| NumericSorterBase (const Glib::RefPtr< ExpressionBase > &expression)
Protected Member Functions inherited from Gtk::Sorter
| Sorter ()
virtual Ordering | compare_vfunc (gpointer item1, gpointer item2)
virtual Order | get_order_vfunc ()

## Additional Inherited Members
Public Types inherited from Gtk::Sorter
enum class | Order { Order::PARTIAL , Order::NONE , Order::TOTAL }
| Describes the type of order that a `Gtk::Sorter` may produce. More...
enum class | Change { DIFFERENT , INVERTED , LESS_STRICT , MORE_STRICT }
Related Symbols inherited from Gtk::NumericSorterBase
Glib::RefPtr< Gtk::NumericSorterBase > | wrap (GtkNumericSorter *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Sorter
Glib::RefPtr< Gtk::Sorter > | wrap (GtkSorter *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

template<class T>
class Gtk::NumericSorter< T >

Sort by comparing numbers.

Gtk::NumericSorter is a Gtk::Sorter that compares numbers.

To obtain the numbers to compare, this sorter evaluates a Gtk::Expression.

See also
  Gtk::Expression

Since gtkmm 3.98

## Constructor & Destructor Documentation

## ◆ NumericSorter()

template <class T >

Gtk::NumericSorter< T >::NumericSorter | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |
| protected

## Member Function Documentation

## ◆ create()

template <class T >

static Glib::RefPtr< NumericSorter > Gtk::NumericSorter< T >::create | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |
| static

## ◆ get_expression() [1/2]

template <class T >

Glib::RefPtr< Expression< T > > Gtk::NumericSorter< T >::get_expression | ( |  | ) |

Gets the expression that is evaluated to obtain numbers from items.

Returns
  A Gtk::Expression, or `nullptr`.

## ◆ get_expression() [2/2]

template <class T >

Glib::RefPtr< const Expression< T > > Gtk::NumericSorter< T >::get_expression | ( |  | ) | const

Gets the expression that is evaluated to obtain numbers from items.

Returns
  A Gtk::Expression, or `nullptr`.

## ◆ property_expression() [1/2]

template <class T >

Glib::PropertyProxy< Glib::RefPtr< Expression< T > > > Gtk::NumericSorter< T >::property_expression | ( |  | ) |

The expression to evalute on items to get a number to compare with.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_expression() [2/2]

template <class T >

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< T > > > Gtk::NumericSorter< T >::property_expression | ( |  | ) | const

The expression to evalute on items to get a number to compare with.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_expression()

template <class T >

void Gtk::NumericSorter< T >::set_expression | ( | const Glib::RefPtr< Expression< T > > & | expression | ) |

Sets the expression that is evaluated to obtain numbers from items.

Unless an expression is set on the Gtk::NumericSorter, the sorter will always compare items as invalid.

The expression must have a return type that can be compared numerically, such as int or double.

Parameters

  expression | A Gtk::Expression, or `nullptr`.